/****************************************************************************
 ***                                                                      ***
 ***   Rubens Sawaya Altimari                     Nmero USP: 3.286.287   ***
 ***   CH - Contructive Heuristics                                        ***
 ***                                                                      ***
 ****************************************************************************/

#include "log.h"

/****************************************************************************
 ***   Defines e TypeDefs                                                 ***
 ****************************************************************************/

/****************************************************************************
 ***   Globals                                                            ***
 ****************************************************************************/

extern FILE* fLog; 

/****************************************************************************
 ***   Local Prototypes                                                   ***
 ****************************************************************************/

/****************************************************************************
 ***   Exported Functions                                                 ***
 ****************************************************************************/

/****************************************************************************
 ***   LogPecas                                                           ***
 ***     Lista o conjunto I de peas                                      ***
 ****************************************************************************/

void Log(char* s)
{
  if (fLog)
    fprintf(fLog, "%s\n", s);
}
/****************************************************************************/
void LogChapa(PChapa R, Pecas I, int N)
{
  printf("Chapa R: %10.2lf(W) x %10.2lf(W)\n", R->W, R->L);
  printf("Pecas P: %d\n\n", N);

  if (fLog) {
    fprintf(fLog, "Chapa R: %20.10lf(W) x %20.10lf(W)\n", R->W, R->L);
    fprintf(fLog, "Pecas P: %d\n", N);
  }
}
/****************************************************************************/
void LogPecas(PChapa R, Pecas I, int N)
{
  double area = 0.0, custo = 0.0, custototal = 0.0;
  int    i, total = 0;

  if (fLog == NULL)
    return;

  printf("-------------------------------------------------------------\n");
  printf("    i        raio      custo        c/r          x          y\n");
  printf("-------------------------------------------------------------\n");
  fprintf(fLog, "---------------------------------------------------------------------------------------------------------------\n");
  fprintf(fLog, "    i                  raio                custo                  c/r                    x                    y\n");
  fprintf(fLog, "---------------------------------------------------------------------------------------------------------------\n");

  for (i = 0; i < N; ++i)
  {
    if (I[i].o.x < R->W) {
      ++total; area += PI * QUAD(I[i].r); custo += I[i].c;
      printf("*"); fprintf(fLog, "*");
    }
    else {
      printf(" "); fprintf(fLog, " ");
    }
    printf ("%4d: %10.2lf %10.2lf %10.2lf %10.2lf %10.2lf\n",
            I[i].i, I[i].r, I[i].c, I[i].c/I[i].r, I[i].o.x, I[i].o.y);
    fprintf(fLog, "%4d: %20.10lf %20.10lf %20.10lf %20.10lf %20.10lf\n",
            I[i].i, I[i].r, I[i].c, I[i].c/I[i].r, I[i].o.x, I[i].o.y);
    custototal += I[i].c;
  }
  printf("------------------------------------------------------------\n");
  fprintf(fLog, "--------------------------------------------------------------------------------------------------------------\n");
  printf("Pecas Colocadas: %10d\n", total);
  printf("Custo Incluido : %10.2lf (%5.2lf%)\n", custo, 100*custo/custototal);
  printf("Area Ocupada   : %10.2lf (%5.2lf%)\n", area, 100*area/(R->W*R->L));
  fprintf(fLog, "Pecas Colocadas: %10d\n", total);
  fprintf(fLog, "Custo Incluido : %10.2lf (%5.2lf%)\n", custo, 100*custo/custototal);
  fprintf(fLog, "Area Ocupada   : %10.2lf (%5.2lf%)\n", area, 100*area/(R->W*R->L));
}
/****************************************************************************/
void LogPeca(PPeca p)
{
  if (fLog)
    fprintf(fLog, "----------\nPeca: P%d, raio %10.2lf\n", p->i, p->r);
}
/****************************************************************************/
void LogTentativaPonto(char* pos, PPonto t)
{
  if (fLog)
    fprintf(fLog, "         Ponto: %-10.10s (%10.2lf,%10.2lf) - ", pos, t->x, t->y);
}
/****************************************************************************/
void LogTentativaPeca(PPeca p)
{
  if (fLog)
    fprintf(fLog, "    1-Adjacencia : P%d\n", p->i);
}
/****************************************************************************/
void LogTentativaPecas(PPeca p1, PPeca p2)
{
  if (fLog)
    fprintf(fLog, "    2-Adjacencias: P%d e P%d\n", p1->i, p2->i);
}
/****************************************************************************/
void LogResultadoOK(void)
{
  if (fLog)
    fprintf(fLog, "OK\n");
}
/****************************************************************************/
void LogResultadoForaDaChapa(void)
{
  if (fLog)
    fprintf(fLog, "Fora da Chapa\n");
}
/****************************************************************************/
void LogResultadoMaisLonge(void)
{
  if (fLog)
    fprintf(fLog, "Mais Longe\n");
}
/****************************************************************************/
void LogResultadoBateu(PPeca p)
{
  if (fLog)
    fprintf(fLog, "Bateu em P%d\n", p->i);
}
/****************************************************************************/

