/****************************************************************************
 ***                                                                      ***
 ***   Rubens Sawaya Altimari                     Nmero USP: 3.286.287   ***
 ***   Definicao de Pecas                                                 ***
 ***                                                                      ***
 ****************************************************************************/

#include <stdlib.h>
#include "struts.h"

/****************************************************************************
 ***   Defines e TypeDefs                                                 ***
 ****************************************************************************/

/****************************************************************************
 ***   Globals                                                            ***
 ****************************************************************************/

/****************************************************************************
 ***   Local Prototypes                                                   ***
 ****************************************************************************/

void exchange (PPeca a, PPeca b);
int  partition(Pecas p, int l, int r, PMenor less);
void quicksort(Pecas p, int l, int r, PMenor less);

/****************************************************************************
 ***   Local Functions                                                    ***
 ****************************************************************************/

void exchange(PPeca a, PPeca b)
{
  Peca t = *a; *a = *b; *b = t;
}
/****************************************************************************/
int partition(Pecas p, int l, int r, PMenor less)
{
  int   i = l-1,
        j = r;
  PPeca v = p + r;

  for (;;) {
    while (less(p + ++i, v));
    while (less(v, p + --j)) if (j == l) break;
    if (i >= j) break;
    exchange(p + i, p + j);
  }
  exchange(p + i, p + r);
  return i;
}
/****************************************************************************/
void quicksort(Pecas p, int l, int r, PMenor less)
{
  if (r > l) {
    int i = partition(p, l, r, less);
    quicksort(p, l, i-1, less);
    quicksort(p, i+1, r, less);
  }
}

/****************************************************************************
 ***   Exported Functions                                                 ***
 ****************************************************************************/

/****************************************************************************
 ***   PecasCarrega                                                       ***
 ***     L arquivo e monta estruturas de pecas e chapa                   ***
 ****************************************************************************/
int PecasCarrega(char* arquivo, PChapa pR, PPecas pI, int* pN)
{
  FILE*  f;
  int    i;
  double r, c;

  /* L arquivo de entrada */
  if ((f = fopen(arquivo, "r")) != NULL)
  {
    /* 1a. linha: W x L (tamanho da chapa R)                  */
    fscanf(f, "%lf %lf", &pR->W, &pR->L);
    pR->first = NULL;
    pR->last  = NULL;

    /* 2a. linha: N (nmero de peas)                         */
    fscanf(f, "%d", pN);

    /* 3a. linha em diante: r (raio) e c (custo) de cada pea */
    *pI = PecasAloca(*pN);
    for (i=0; i < *pN; ++i)
    {
      fscanf(f, "%lf %lf", &r, &c);
      (*pI)[i].i    = i;
      (*pI)[i].r    = r;
      (*pI)[i].c    = c;
      (*pI)[i].o.x  = 0.0;
      (*pI)[i].o.y  = 0.0;
      (*pI)[i].next = NULL;
      (*pI)[i].adj  = NULL;
    }

    fclose(f);
    return TRUE;
  }
  printf("\nArquivo %s Invalido!\n\n", arquivo);
  return FALSE;
}
/****************************************************************************/
Pecas PecasAloca(int N)
{
  Pecas pecas = (Pecas) malloc(N * sizeof(Peca));

  if (!pecas)
    printf("\nMemoria Insuficiente!\n\n");
  return pecas;
}
/****************************************************************************/
void PecasDesaloca(Pecas I, int N)
{
  PAdj a, b;
  int  i;

  for (i = 0; i < N; ++i)
    for (a = I[i].adj; a != NULL; ) {
      b = a->next;
      free(a);
      a = b;
    }
  free(I);
}
/****************************************************************************/
void PecasOrdena(Pecas I, int N, PMenor F)
{
  quicksort(I, 0, N-1, F);
}

