/****************************************************************************/

#ifndef strutsH
#define strutsH

/****************************************************************************
 ***   Includes                                                           ***
 ****************************************************************************/

#include <stdio.h>

/****************************************************************************
 ***   Defines e TypeDefs                                                 ***
 ****************************************************************************/

#define FALSE 0
#define TRUE  1
#define PI    3.14159

#define MINDOUBLE    0.000000001l
#define IG(a,b)      (fabs((a)-(b))<MINDOUBLE ? TRUE : FALSE)
#define MNIG(a,b)    ((a)<(b)? TRUE : IG(a,b))
#define QUAD(a)      ((a)*(a))
#define QDIST0(p)    (QUAD(p.x) + QUAD(p.y))
#define QDIST(p1,p2) (QUAD(p1.x-p2.x) + QUAD(p1.y-p2.y))

typedef struct MyPonto* PPonto;
typedef struct MyAdj*   PAdj;
typedef struct MyPeca*  PPeca;

typedef struct MyPonto {
  double x,
         y;
} Ponto;

typedef struct MyAdj {
  PPeca peca;
  PAdj  next;
} Adj;

typedef struct MyPeca {
  int    i;
  double r,
         c;
  Ponto  o;
  PPeca  next;
  PAdj   adj;
} Peca;

typedef PPeca  Pecas;
typedef Pecas* PPecas;

typedef struct MyChapa* PChapa;
typedef struct MyChapa {
  double W,
         L;
  PPeca  first,
         last;
} Chapa;

typedef int (*PMenor)      (PPeca, PPeca);
typedef int (*PHeuristica) (PChapa, Pecas, int);

/****************************************************************************
 ***   Exported Functions                                                 ***
 ****************************************************************************/

int   PecasCarrega  (char* arquivo, PChapa pR, PPecas pI, int* pN);
Pecas PecasAloca    (int N);
void  PecasDesaloca (Pecas I, int N);
void  PecasOrdena   (Pecas I, int N, PMenor F);

/****************************************************************************/

#endif

